"use strict";exports=module.exports=fetch;const http=require("http"),https=require("https"),zlib=require("zlib"),Stream=require("stream"),dataUriToBuffer=require("data-uri-to-buffer"),util=require("util"),Blob=require("fetch-blob"),crypto=require("crypto"),url=require("url");class FetchBaseError extends Error{constructor(e,t){super(e),Error.captureStackTrace(this,this.constructor),this.type=t}get name(){return this.constructor.name}get[Symbol.toStringTag](){return this.constructor.name}}class FetchError extends FetchBaseError{constructor(e,t,r){super(e,t),r&&(this.code=this.errno=r.code,this.erroredSysCall=r.syscall)}}const NAME=Symbol.toStringTag,isURLSearchParameters=e=>"object"==typeof e&&"function"==typeof e.append&&"function"==typeof e.delete&&"function"==typeof e.get&&"function"==typeof e.getAll&&"function"==typeof e.has&&"function"==typeof e.set&&"function"==typeof e.sort&&"URLSearchParams"===e[NAME],isBlob=e=>"object"==typeof e&&"function"==typeof e.arrayBuffer&&"string"==typeof e.type&&"function"==typeof e.stream&&"function"==typeof e.constructor&&/^(Blob|File)$/.test(e[NAME]);function isFormData(e){return"object"==typeof e&&"function"==typeof e.append&&"function"==typeof e.set&&"function"==typeof e.get&&"function"==typeof e.getAll&&"function"==typeof e.delete&&"function"==typeof e.keys&&"function"==typeof e.values&&"function"==typeof e.entries&&"function"==typeof e.constructor&&"FormData"===e[NAME]}const isAbortSignal=e=>"object"==typeof e&&"AbortSignal"===e[NAME],carriage="\r\n",dashes="-".repeat(2),carriageLength=Buffer.byteLength(carriage),getFooter=e=>`${dashes}${e}${dashes}${carriage.repeat(2)}`;function getHeader(e,t,r){let o="";return o+=`${dashes}${e}${carriage}`,o+=`Content-Disposition: form-data; name="${t}"`,isBlob(r)&&(o+=`; filename="${r.name}"${carriage}`,o+=`Content-Type: ${r.type||"application/octet-stream"}`),`${o}${carriage.repeat(2)}`}const getBoundary=()=>crypto.randomBytes(8).toString("hex");async function*formDataIterator(e,t){for(const[r,o]of e)yield getHeader(t,r,o),isBlob(o)?yield*o.stream():yield o,yield carriage;yield getFooter(t)}function getFormDataLength(e,t){let r=0;for(const[o,s]of e)r+=Buffer.byteLength(getHeader(t,o,s)),isBlob(s)?r+=s.size:r+=Buffer.byteLength(String(s)),r+=carriageLength;return r+=Buffer.byteLength(getFooter(t)),r}const INTERNALS$2=Symbol("Body internals");class Body{constructor(e,{size:t=0}={}){let r=null;null===e?e=null:isURLSearchParameters(e)?e=Buffer.from(e.toString()):isBlob(e)||Buffer.isBuffer(e)||(util.types.isAnyArrayBuffer(e)?e=Buffer.from(e):ArrayBuffer.isView(e)?e=Buffer.from(e.buffer,e.byteOffset,e.byteLength):e instanceof Stream||(isFormData(e)?(r=`NodeFetchFormDataBoundary${getBoundary()}`,e=Stream.Readable.from(formDataIterator(e,r))):e=Buffer.from(String(e)))),this[INTERNALS$2]={body:e,boundary:r,disturbed:!1,error:null},this.size=t,e instanceof Stream&&e.on("error",(e=>{const t=e instanceof FetchBaseError?e:new FetchError(`Invalid response body while trying to fetch ${this.url}: ${e.message}`,"system",e);this[INTERNALS$2].error=t}))}get body(){return this[INTERNALS$2].body}get bodyUsed(){return this[INTERNALS$2].disturbed}async arrayBuffer(){const{buffer:e,byteOffset:t,byteLength:r}=await consumeBody(this);return e.slice(t,t+r)}async blob(){const e=this.headers&&this.headers.get("content-type")||this[INTERNALS$2].body&&this[INTERNALS$2].body.type||"",t=await this.buffer();return new Blob([t],{type:e})}async json(){const e=await consumeBody(this);return JSON.parse(e.toString())}async text(){return(await consumeBody(this)).toString()}buffer(){return consumeBody(this)}}async function consumeBody(e){if(e[INTERNALS$2].disturbed)throw new TypeError(`body used already for: ${e.url}`);if(e[INTERNALS$2].disturbed=!0,e[INTERNALS$2].error)throw e[INTERNALS$2].error;let{body:t}=e;if(null===t)return Buffer.alloc(0);if(isBlob(t)&&(t=t.stream()),Buffer.isBuffer(t))return t;if(!(t instanceof Stream))return Buffer.alloc(0);const r=[];let o=0;try{for await(const s of t){if(e.size>0&&o+s.length>e.size){const r=new FetchError(`content size at ${e.url} over limit: ${e.size}`,"max-size");throw t.destroy(r),r}o+=s.length,r.push(s)}}catch(t){throw t instanceof FetchBaseError?t:new FetchError(`Invalid response body while trying to fetch ${e.url}: ${t.message}`,"system",t)}if(!0!==t.readableEnded&&!0!==t._readableState.ended)throw new FetchError(`Premature close of server response while trying to fetch ${e.url}`);try{return r.every((e=>"string"==typeof e))?Buffer.from(r.join("")):Buffer.concat(r,o)}catch(t){throw new FetchError(`Could not create Buffer from response body for ${e.url}: ${t.message}`,"system",t)}}Object.defineProperties(Body.prototype,{body:{enumerable:!0},bodyUsed:{enumerable:!0},arrayBuffer:{enumerable:!0},blob:{enumerable:!0},json:{enumerable:!0},text:{enumerable:!0}});const clone=(e,t)=>{let r,o,{body:s}=e;if(e.bodyUsed)throw new Error("cannot clone body after it is used");return s instanceof Stream&&"function"!=typeof s.getBoundary&&(r=new Stream.PassThrough({highWaterMark:t}),o=new Stream.PassThrough({highWaterMark:t}),s.pipe(r),s.pipe(o),e[INTERNALS$2].body=r,s=o),s},extractContentType=(e,t)=>null===e?null:"string"==typeof e?"text/plain;charset=UTF-8":isURLSearchParameters(e)?"application/x-www-form-urlencoded;charset=UTF-8":isBlob(e)?e.type||null:Buffer.isBuffer(e)||util.types.isAnyArrayBuffer(e)||ArrayBuffer.isView(e)?null:e&&"function"==typeof e.getBoundary?`multipart/form-data;boundary=${e.getBoundary()}`:isFormData(e)?`multipart/form-data; boundary=${t[INTERNALS$2].boundary}`:e instanceof Stream?null:"text/plain;charset=UTF-8",getTotalBytes=e=>{const{body:t}=e;return null===t?0:isBlob(t)?t.size:Buffer.isBuffer(t)?t.length:t&&"function"==typeof t.getLengthSync?t.hasKnownLength&&t.hasKnownLength()?t.getLengthSync():null:isFormData(t)?getFormDataLength(e[INTERNALS$2].boundary):null},writeToStream=(e,{body:t})=>{null===t?e.end():isBlob(t)?t.stream().pipe(e):Buffer.isBuffer(t)?(e.write(t),e.end()):t.pipe(e)},validateHeaderName="function"==typeof http.validateHeaderName?http.validateHeaderName:e=>{if(!/^[\^`\-\w!#$%&'*+.|~]+$/.test(e)){const t=new TypeError(`Header name must be a valid HTTP token [${e}]`);throw Object.defineProperty(t,"code",{value:"ERR_INVALID_HTTP_TOKEN"}),t}},validateHeaderValue="function"==typeof http.validateHeaderValue?http.validateHeaderValue:(e,t)=>{if(/[^\t\u0020-\u007E\u0080-\u00FF]/.test(t)){const t=new TypeError(`Invalid character in header content ["${e}"]`);throw Object.defineProperty(t,"code",{value:"ERR_INVALID_CHAR"}),t}};class Headers extends URLSearchParams{constructor(e){let t=[];if(e instanceof Headers){const r=e.raw();for(const[e,o]of Object.entries(r))t.push(...o.map((t=>[e,t])))}else if(null==e);else{if("object"!=typeof e||util.types.isBoxedPrimitive(e))throw new TypeError("Failed to construct 'Headers': The provided value is not of type '(sequence<sequence<ByteString>> or record<ByteString, ByteString>)");{const r=e[Symbol.iterator];if(null==r)t.push(...Object.entries(e));else{if("function"!=typeof r)throw new TypeError("Header pairs must be iterable");t=[...e].map((e=>{if("object"!=typeof e||util.types.isBoxedPrimitive(e))throw new TypeError("Each header pair must be an iterable object");return[...e]})).map((e=>{if(2!==e.length)throw new TypeError("Each header pair must be a name/value tuple");return[...e]}))}}}return t=t.length>0?t.map((([e,t])=>(validateHeaderName(e),validateHeaderValue(e,String(t)),[String(e).toLowerCase(),String(t)]))):void 0,super(t),new Proxy(this,{get(e,t,r){switch(t){case"append":case"set":return(r,o)=>(validateHeaderName(r),validateHeaderValue(r,String(o)),URLSearchParams.prototype[t].call(e,String(r).toLowerCase(),String(o)));case"delete":case"has":case"getAll":return r=>(validateHeaderName(r),URLSearchParams.prototype[t].call(e,String(r).toLowerCase()));case"keys":return()=>(e.sort(),new Set(URLSearchParams.prototype.keys.call(e)).keys());default:return Reflect.get(e,t,r)}}})}get[Symbol.toStringTag](){return this.constructor.name}toString(){return Object.prototype.toString.call(this)}get(e){const t=this.getAll(e);if(0===t.length)return null;let r=t.join(", ");return/^content-encoding$/i.test(e)&&(r=r.toLowerCase()),r}forEach(e){for(const t of this.keys())e(this.get(t),t)}*values(){for(const e of this.keys())yield this.get(e)}*entries(){for(const e of this.keys())yield[e,this.get(e)]}[Symbol.iterator](){return this.entries()}raw(){return[...this.keys()].reduce(((e,t)=>(e[t]=this.getAll(t),e)),{})}[Symbol.for("nodejs.util.inspect.custom")](){return[...this.keys()].reduce(((e,t)=>{const r=this.getAll(t);return e[t]="host"===t?r[0]:r.length>1?r:r[0],e}),{})}}function fromRawHeaders(e=[]){return new Headers(e.reduce(((e,t,r,o)=>(r%2==0&&e.push(o.slice(r,r+2)),e)),[]).filter((([e,t])=>{try{return validateHeaderName(e),validateHeaderValue(e,String(t)),!0}catch{return!1}})))}Object.defineProperties(Headers.prototype,["get","entries","forEach","values"].reduce(((e,t)=>(e[t]={enumerable:!0},e)),{}));const redirectStatus=new Set([301,302,303,307,308]),isRedirect=e=>redirectStatus.has(e),INTERNALS$1=Symbol("Response internals");class Response extends Body{constructor(e=null,t={}){super(e,t);const r=t.status||200,o=new Headers(t.headers);if(null!==e&&!o.has("Content-Type")){const t=extractContentType(e);t&&o.append("Content-Type",t)}this[INTERNALS$1]={url:t.url,status:r,statusText:t.statusText||"",headers:o,counter:t.counter,highWaterMark:t.highWaterMark}}get url(){return this[INTERNALS$1].url||""}get status(){return this[INTERNALS$1].status}get ok(){return this[INTERNALS$1].status>=200&&this[INTERNALS$1].status<300}get redirected(){return this[INTERNALS$1].counter>0}get statusText(){return this[INTERNALS$1].statusText}get headers(){return this[INTERNALS$1].headers}get highWaterMark(){return this[INTERNALS$1].highWaterMark}clone(){return new Response(clone(this,this.highWaterMark),{url:this.url,status:this.status,statusText:this.statusText,headers:this.headers,ok:this.ok,redirected:this.redirected,size:this.size})}static redirect(e,t=302){if(!isRedirect(t))throw new RangeError('Failed to execute "redirect" on "response": Invalid status code');return new Response(null,{headers:{location:new URL(e).toString()},status:t})}get[Symbol.toStringTag](){return"Response"}}Object.defineProperties(Response.prototype,{url:{enumerable:!0},status:{enumerable:!0},ok:{enumerable:!0},redirected:{enumerable:!0},statusText:{enumerable:!0},headers:{enumerable:!0},clone:{enumerable:!0}});const getSearch=e=>{if(e.search)return e.search;const t=e.href.length-1,r=e.hash||("#"===e.href[t]?"#":"");return"?"===e.href[t-r.length]?"?":""},INTERNALS=Symbol("Request internals"),isRequest=e=>"object"==typeof e&&"object"==typeof e[INTERNALS];class Request extends Body{constructor(e,t={}){let r;isRequest(e)?r=new URL(e.url):(r=new URL(e),e={});let o=t.method||e.method||"GET";if(o=o.toUpperCase(),(null!=t.body||isRequest(e))&&null!==e.body&&("GET"===o||"HEAD"===o))throw new TypeError("Request with GET/HEAD method cannot have body");const s=t.body?t.body:isRequest(e)&&null!==e.body?clone(e):null;super(s,{size:t.size||e.size||0});const n=new Headers(t.headers||e.headers||{});if(null!==s&&!n.has("Content-Type")){const e=extractContentType(s,this);e&&n.append("Content-Type",e)}let a=isRequest(e)?e.signal:null;if("signal"in t&&(a=t.signal),null!==a&&!isAbortSignal(a))throw new TypeError("Expected signal to be an instanceof AbortSignal");this[INTERNALS]={method:o,redirect:t.redirect||e.redirect||"follow",headers:n,parsedURL:r,signal:a},this.follow=void 0===t.follow?void 0===e.follow?20:e.follow:t.follow,this.compress=void 0===t.compress?void 0===e.compress||e.compress:t.compress,this.counter=t.counter||e.counter||0,this.agent=t.agent||e.agent,this.highWaterMark=t.highWaterMark||e.highWaterMark||16384,this.insecureHTTPParser=t.insecureHTTPParser||e.insecureHTTPParser||!1}get method(){return this[INTERNALS].method}get url(){return url.format(this[INTERNALS].parsedURL)}get headers(){return this[INTERNALS].headers}get redirect(){return this[INTERNALS].redirect}get signal(){return this[INTERNALS].signal}clone(){return new Request(this)}get[Symbol.toStringTag](){return"Request"}}Object.defineProperties(Request.prototype,{method:{enumerable:!0},url:{enumerable:!0},headers:{enumerable:!0},redirect:{enumerable:!0},clone:{enumerable:!0},signal:{enumerable:!0}});const getNodeRequestOptions=e=>{const{parsedURL:t}=e[INTERNALS],r=new Headers(e[INTERNALS].headers);r.has("Accept")||r.set("Accept","*/*");let o=null;if(null===e.body&&/^(post|put)$/i.test(e.method)&&(o="0"),null!==e.body){const t=getTotalBytes(e);"number"!=typeof t||Number.isNaN(t)||(o=String(t))}o&&r.set("Content-Length",o),r.has("User-Agent")||r.set("User-Agent","node-fetch"),e.compress&&!r.has("Accept-Encoding")&&r.set("Accept-Encoding","gzip,deflate,br");let{agent:s}=e;"function"==typeof s&&(s=s(t)),r.has("Connection")||s||r.set("Connection","close");const n=getSearch(t);return{path:t.pathname+n,pathname:t.pathname,hostname:t.hostname,protocol:t.protocol,port:t.port,hash:t.hash,search:t.search,query:t.query,href:t.href,method:e.method,headers:r[Symbol.for("nodejs.util.inspect.custom")](),insecureHTTPParser:e.insecureHTTPParser,agent:s}};class AbortError extends FetchBaseError{constructor(e,t="aborted"){super(e,t)}}const supportedSchemas=new Set(["data:","http:","https:"]);async function fetch(e,t){return new Promise(((r,o)=>{const s=new Request(e,t),n=getNodeRequestOptions(s);if(!supportedSchemas.has(n.protocol))throw new TypeError(`node-fetch cannot load ${e}. URL scheme "${n.protocol.replace(/:$/,"")}" is not supported.`);if("data:"===n.protocol){const e=dataUriToBuffer(s.url),t=new Response(e,{headers:{"Content-Type":e.typeFull}});return void r(t)}const a=("https:"===n.protocol?https:http).request,{signal:i}=s;let u=null;const c=()=>{const e=new AbortError("The operation was aborted.");o(e),s.body&&s.body instanceof Stream.Readable&&s.body.destroy(e),u&&u.body&&u.body.emit("error",e)};if(i&&i.aborted)return void c();const l=()=>{c(),h()},d=a(n);i&&i.addEventListener("abort",l);const h=()=>{d.abort(),i&&i.removeEventListener("abort",l)};d.on("error",(e=>{o(new FetchError(`request to ${s.url} failed, reason: ${e.message}`,"system",e)),h()})),d.on("response",(e=>{d.setTimeout(0);const n=fromRawHeaders(e.rawHeaders);if(isRedirect(e.statusCode)){const a=n.get("Location"),i=null===a?null:new URL(a,s.url);switch(s.redirect){case"error":return o(new FetchError(`uri requested responds with a redirect, redirect mode is set to error: ${s.url}`,"no-redirect")),void h();case"manual":if(null!==i)try{n.set("Location",i)}catch(e){o(e)}break;case"follow":{if(null===i)break;if(s.counter>=s.follow)return o(new FetchError(`maximum redirect reached at: ${s.url}`,"max-redirect")),void h();const n={headers:new Headers(s.headers),follow:s.follow,counter:s.counter+1,agent:s.agent,compress:s.compress,method:s.method,body:s.body,signal:s.signal,size:s.size};return 303!==e.statusCode&&s.body&&t.body instanceof Stream.Readable?(o(new FetchError("Cannot follow redirect with body being a readable stream","unsupported-redirect")),void h()):(303!==e.statusCode&&(301!==e.statusCode&&302!==e.statusCode||"POST"!==s.method)||(n.method="GET",n.body=void 0,n.headers.delete("content-length")),r(fetch(new Request(i,n))),void h())}}}e.once("end",(()=>{i&&i.removeEventListener("abort",l)}));let a=Stream.pipeline(e,new Stream.PassThrough,(e=>{o(e)}));process.version<"v12.10"&&e.on("aborted",l);const c={url:s.url,status:e.statusCode,statusText:e.statusMessage,headers:n,size:s.size,counter:s.counter,highWaterMark:s.highWaterMark},f=n.get("Content-Encoding");if(!s.compress||"HEAD"===s.method||null===f||204===e.statusCode||304===e.statusCode)return u=new Response(a,c),void r(u);const p={flush:zlib.Z_SYNC_FLUSH,finishFlush:zlib.Z_SYNC_FLUSH};if("gzip"===f||"x-gzip"===f)return a=Stream.pipeline(a,zlib.createGunzip(p),(e=>{o(e)})),u=new Response(a,c),void r(u);if("deflate"!==f&&"x-deflate"!==f){if("br"===f)return a=Stream.pipeline(a,zlib.createBrotliDecompress(),(e=>{o(e)})),u=new Response(a,c),void r(u);u=new Response(a,c),r(u)}else Stream.pipeline(e,new Stream.PassThrough,(e=>{o(e)})).once("data",(e=>{a=8==(15&e[0])?Stream.pipeline(a,zlib.createInflate(),(e=>{o(e)})):Stream.pipeline(a,zlib.createInflateRaw(),(e=>{o(e)})),u=new Response(a,c),r(u)}))})),writeToStream(d,s)}))}exports.AbortError=AbortError,exports.FetchError=FetchError,exports.Headers=Headers,exports.Request=Request,exports.Response=Response,exports.default=fetch,exports.isRedirect=isRedirect;